#include "ty_rtc.h"
#include "nrf_drv_rtc.h"




/*********************************************************************
 * LOCAL CONSTANT
 */

/*********************************************************************
 * LOCAL STRUCT
 */

/*********************************************************************
 * LOCAL VARIABLE
 */
const nrf_drv_rtc_t ty_rtc_handle = NRF_DRV_RTC_INSTANCE(2);
static uint32_t s_local_timestamp = 0;
static uint32_t s_local_timestamp_when_update = 0;
static uint32_t s_app_timestamp_when_update = 0;

/*********************************************************************
 * VARIABLE
 */

/*********************************************************************
 * LOCAL FUNCTION
 */




/*********************************************************
FN: 
*/
static void ty_rtc_handler(nrf_drv_rtc_int_type_t int_type)
{
    static uint16_t count = 0;
    if(int_type == NRF_DRV_RTC_INT_TICK) {
        count++;
        if(count == 8) {
            count=0;
            s_local_timestamp++;
        }
    }
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_init(void)
{
    uint32_t ret;
    
    //Initialize RTC instance
    nrf_drv_rtc_config_t config = NRF_DRV_RTC_DEFAULT_CONFIG;
    config.prescaler = 4095;
    ret = nrf_drv_rtc_init(&ty_rtc_handle, &config, ty_rtc_handler);
    APP_ERROR_CHECK(ret);
    
    //Enable tick event & interrupt
    nrf_drv_rtc_tick_enable(&ty_rtc_handle, true);
    
    //Power on RTC instance
    nrf_drv_rtc_enable(&ty_rtc_handle);
    
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_set_time(uint32_t timestamp)
{
    s_local_timestamp_when_update = s_local_timestamp;
    s_app_timestamp_when_update = timestamp;
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_get_time(uint32_t* p_timestamp)
{
    *p_timestamp = (s_app_timestamp_when_update + (s_local_timestamp - s_local_timestamp_when_update));
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_get_local_time(uint32_t* p_timestamp)
{
    *p_timestamp = s_local_timestamp;
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_get_old_time(uint32_t old_local_timestamp, uint32_t* p_timestamp)
{
    uint32_t timestamp = 0;
    ty_rtc_get_time(&timestamp);
    *p_timestamp = (timestamp - (s_local_timestamp - old_local_timestamp));
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_control(uint8_t cmd, void* arg)
{
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_uninit(void)
{
    nrf_drv_rtc_uninit(&ty_rtc_handle);
    return 0;
}







