#include "ty_uart.h"
#include "tuya_ble_api.h"
#include "pca10040.h"
#include "nrf_uart.h"
#include "app_uart.h"




/*********************************************************************
 * LOCAL CONSTANT
 */
            
/*********************************************************************
 * LOCAL STRUCT
 */

/*********************************************************************
 * LOCAL VARIABLE
 */
static volatile bool uart_is_init = false;

/*********************************************************************
 * VARIABLE
 */

/*********************************************************************
 * LOCAL FUNCTION
 */




/*********************************************************
FN: 
*/
static void ty_uart_rx_handler(app_uart_evt_t * p_event)
{
    uint8_t rx_char;

    switch (p_event->evt_type)
    {
        case APP_UART_DATA_READY: {
            UNUSED_VARIABLE(app_uart_get(&rx_char));
            tuya_ble_common_uart_receive_data(&rx_char, 1);
        } break;

        case APP_UART_TX_EMPTY: {
        } break;

        case APP_UART_COMMUNICATION_ERROR: {
            app_uart_flush();
            app_uart_close();
            ty_uart_init();
//            APP_ERROR_HANDLER(p_event->data.error_communication);
        } break;

        case APP_UART_FIFO_ERROR: {
//            APP_ERROR_HANDLER(p_event->data.error_code);
        } break;

        default: {
        } break;
    }
}
uint32_t ty_uart_init(void)
{
    uint32_t ret;
    app_uart_comm_params_t const comm_params =
    {
        .rx_pin_no    = RX_PIN_NUMBER,
        .tx_pin_no    = TX_PIN_NUMBER,
        .rts_pin_no   = RTS_PIN_NUMBER,
        .cts_pin_no   = CTS_PIN_NUMBER,
        .flow_control = APP_UART_FLOW_CONTROL_DISABLED,
        .use_parity   = false,
        .baud_rate    = NRF_UART_BAUDRATE_9600
    };

    APP_UART_FIFO_INIT(&comm_params,
                       512,
                       512,
                       ty_uart_rx_handler,
                       APP_IRQ_PRIORITY_LOW, //APP_IRQ_PRIORITY_LOWEST,
                       ret);
    APP_ERROR_CHECK(ret);
    if(ret == NRF_SUCCESS) {
        uart_is_init = true;
    }
    return ret;
}

/*********************************************************
FN: 
*/
uint32_t ty_uart2_init(void)
{
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_uart_send(const uint8_t* buf, uint32_t size)
{
    if(uart_is_init) {
        for(uint32_t idx=0; idx<size; idx++) {
            uint32_t ret = app_uart_put(buf[idx]);
//            APP_ERROR_CHECK(ret);
            if(ret != NRF_SUCCESS) {
                break;
            }
        }
    }
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_uart2_send(const uint8_t* buf, uint32_t size)
{
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_uart_uninit(void)
{
    uint32_t ret = app_uart_close();
    if(ret == NRF_SUCCESS) {
        uart_is_init = false;
    }
    return ret;
}

/*********************************************************
FN: 
*/
uint32_t ty_uart2_uninit(void)
{
    return 0;
}






